scala.tools.nsc.transform.patmat.MatchOptimization.CommonSubconditionElimination

# ReusedCondTreeMaker

#### class ReusedCondTreeMaker extends TreeMaker

Source
  MatchOptimization.scala

Linear Supertypes
CommonSubconditionElimination.TreeMaker, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ReusedCondTreeMaker
2. TreeMaker
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new ReusedCondTreeMaker(prevBinder: Global.Symbol, nextBinder: Global.Symbol, cond: CommonSubconditionElimination.Tree, res: CommonSubconditionElimination.Tree, pos: Global.Position)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ReusedCondTreeMaker to any2stringadd[ReusedCondTreeMaker] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ReusedCondTreeMaker, B)

   Implicit information
     This member is added by an implicit conversion from ReusedCondTreeMaker to ArrowAssoc[ReusedCondTreeMaker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def chainBefore(next: CommonSubconditionElimination.Tree)(casegen: CommonSubconditionElimination.Casegen): CommonSubconditionElimination.Tree

   Definition Classes
     ReusedCondTreeMaker → TreeMaker

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### def ensuring(cond: (ReusedCondTreeMaker) ⇒ Boolean, msg: ⇒ Any): ReusedCondTreeMaker

   Implicit information
     This member is added by an implicit conversion from ReusedCondTreeMaker to Ensuring[ReusedCondTreeMaker] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: (ReusedCondTreeMaker) ⇒ Boolean): ReusedCondTreeMaker

    Implicit information
      This member is added by an implicit conversion from ReusedCondTreeMaker to Ensuring[ReusedCondTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean, msg: ⇒ Any): ReusedCondTreeMaker

    Implicit information
      This member is added by an implicit conversion from ReusedCondTreeMaker to Ensuring[ReusedCondTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean): ReusedCondTreeMaker

    Implicit information
      This member is added by an implicit conversion from ReusedCondTreeMaker to Ensuring[ReusedCondTreeMaker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ReusedCondTreeMaker to StringFormat[ReusedCondTreeMaker] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

17. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

18. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

20. #### lazy val localSubstitution: CommonSubconditionElimination.Substitution

    Definition Classes
      ReusedCondTreeMaker → TreeMaker

21. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

22. #### val nextBinder: Global.Symbol

23. #### final def notify(): Unit

    Definition Classes
      AnyRef

24. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

25. #### val pos: Global.Position

    Definition Classes
      ReusedCondTreeMaker → TreeMaker

26. #### lazy val storedCond: Global.TermSymbol

27. #### def subPatternsAsSubstitution: CommonSubconditionElimination.Substitution

    The substitution that specifies the trees that compute the values of the subpattern binders.

    The substitution that specifies the trees that compute the values of the subpattern binders.

    Should not be used to perform actual substitution! Only used to reason symbolically about the values the subpattern binders are bound to. See TreeMakerToCond#updateSubstitution.

    Overridden in PreserveSubPatBinders to pretend it replaces the subpattern binders by subpattern refs (Even though we don't do so anymore -- see SI-5158, SI-5739 and SI-6070.)

    TODO: clean this up, would be nicer to have some higher-level way to compute the binders bound by this tree maker and the symbolic values that correspond to them

    Definition Classes
      TreeMaker

28. #### def substitution: CommonSubconditionElimination.Substitution

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    captures the scope and the value of the bindings in patterns important *when* the substitution happens (can't accumulate and do at once after the full matcher has been constructed)

    Definition Classes
      TreeMaker

29. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

30. #### def toString(): String

    Definition Classes
      ReusedCondTreeMaker → AnyRef → Any

31. #### lazy val treesToHoist: List[CommonSubconditionElimination.Tree]

32. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### def →[B](y: B): (ReusedCondTreeMaker, B)

    Implicit information
      This member is added by an implicit conversion from ReusedCondTreeMaker to ArrowAssoc[ReusedCondTreeMaker] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from CommonSubconditionElimination.TreeMaker

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ReusedCondTreeMaker to any2stringadd[ReusedCondTreeMaker]

### Inherited by implicit conversion StringFormat from ReusedCondTreeMaker to StringFormat[ReusedCondTreeMaker]

### Inherited by implicit conversion Ensuring from ReusedCondTreeMaker to Ensuring[ReusedCondTreeMaker]

### Inherited by implicit conversion ArrowAssoc from ReusedCondTreeMaker to ArrowAssoc[ReusedCondTreeMaker]

### Ungrouped